#if !defined(AFX_TCPSOCKET_H__890AB2C4_429F_11D4_93A3_0000E86DCAD8__INCLUDED_)
#define AFX_TCPSOCKET_H__890AB2C4_429F_11D4_93A3_0000E86DCAD8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TCPSocket.h : header file
//

//Ϣ
#define SOCKET_THREAD_READ		WM_USER+1000
#define SOCKET_THREAD_WRITE		WM_USER+1001
#define SOCKET_THREAD_CONNECT	WM_USER+1002
#define SOCKET_THREAD_ACCEPT	WM_USER+1003
#define SOCKET_THREAD_CLOSE		WM_USER+1004
#define SOCKET_THREAD_RESOLVE	WM_USER+1005
#define SOCKET_THREAD_TRANSFER	WM_USER+1006
#define SOCKET_THREAD_SHUT		WM_USER+1007

//״̬
#define	SOCKET_ORIGIN			0	//ûд
#define SOCKET_INIT				1	//Ѿ
#define SOCKET_CONNECTING		2	//
#define SOCKET_CONNECTED		3	//Ѿӣȴշ
#define SOCKET_SENDING			4	//ڷ
#define SOCKET_READING			5	//ڽ
#define SOCKET_QUITING			6	//ڹر
#define SOCKET_ACCEPTING		7	//ڵȴ
#define SOCKET_ACCPETED			8	//Ӻãʼ
#define SOCKET_CLOSED			7	//Ѿر
#define SOCKET_GETNAME			8	//ڽ
#define SOCKET_ERROROCCUR		8	//ִ󣬵ȴ

//socket;
#define SOCKET_CLIENT			0	//ݴ
#define SOCKET_SERVER_LISTEN	1   //
#define SOCKET_SERVER_TRANSFER	2	//ڴ
	//ڵȴ

//
#define SOCKET_ERROR_NOERROR	0	//ûд
#define SOCKET_ERROR_BLOCK		1	//Ϊblockģʽ
#define SOCKET_ERROR_RESET		2	//·reset
#define SOCKET_ERROR_CLOSE		3	//ر
#define SOCKET_ERROR_CONNECT	4	//ʱ
#define SOCKET_ERROR_PACKET		5	//ݰ
#define SOCKET_ERROR_SIZE		6	//Сȷ
#define SOCKET_ERROR_TIMEOUT	7	//ʱ
#define SOCKET_ERROR_INIT		8	//ʼsocketʧ
#define SOCKET_ERROR_CREATE		9	//socketʧ
#define SOCKET_ERROR_REFUSE		10	//ܾ
#define SOCKET_ERROR_HOSTNAME	11	//
#define SOCKET_ERROR_CANCEL		12	//ûȡ
#define SOCKET_ERROR_ACCEPT		13	//ʧ
#define SOCKET_ERROR_SEND		14



#define SOCKET_ERROR_UNKNOWN	100


//CAsyncSocketܵĸĽ̰߳
//Ϣ̣߳Ȼ̵߳óԱɶ
//socketֻSOCK_STREAM첽

#include <afxmt.h>
#include <winsock2.h>

/////////////////////////////////////////////////////////////////////////////
// CTCPSocket command target

class CTCPSocket 
{
// Attributes
public:

// Operations
public:
	CTCPSocket();
	virtual ~CTCPSocket();

// Overrides
public:
	BOOL ChangeHandle();
	LPBYTE GetData(int *nLen);
	int Send(LPBYTE lpBuf, int nLen);
	BOOL Receive();
	CString GetHost();
	BOOL CreateTransfer(CTCPSocket *pSocket, HWND hWnd, BOOL bAsync = TRUE);
	SOCKET GetSocket();
	void StopWait();
	void CancelJob();
	void Close();
	void Stop();
	void EnableWrite();
	BOOL CreateServer(int nPort, HWND hWnd);
	BOOL CreateClient(CString szHost, int nPort, BOOL bUseProxy, HWND hWnd, HWND hFinalWnd);
	int  GetLastError();
	BOOL m_bState;

private:
	int SendFirstPacket();
	BOOL m_bUseProxy;
	BOOL m_bCanWrite;
	int m_nBegin;		//ݿʼλ
	int m_nEnd;			//λ
	LPBYTE m_lpReceiveBuffer;
	LPBYTE m_lpSendBuffer;
	BOOL m_bCancelJob;
	BOOL GetHostIP(CString szHost);
	int  m_nErrorCode;
	SOCKET	m_TCP_s;
	BOOL m_bSocketType;
	HANDLE m_hWaitEvent;
	HWND m_hMainWnd;
	HWND m_hFinalWnd;
	IN_ADDR	ipServer;
	IN_ADDR ipClient;
	CString m_szHost;
	UINT	m_nPort;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TCPSOCKET_H__890AB2C4_429F_11D4_93A3_0000E86DCAD8__INCLUDED_)
