// OptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Chat.h"
#include "OptionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionDlg dialog


COptionDlg::COptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionDlg)
	m_szIP = _T("");
	m_szName = _T("");
	m_nServicePort = 0;
	m_nProxyPort = 0;
	m_nProxyType = -1;
	m_szProxy = _T("");
	m_bUseProxy = FALSE;
	m_nWaitTime = -1;
	//}}AFX_DATA_INIT
}


void COptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionDlg)
	DDX_Text(pDX, IDC_OPTION_IP, m_szIP);
	DDV_MaxChars(pDX, m_szIP, 16);
	DDX_Text(pDX, IDC_OPTION_NAME, m_szName);
	DDV_MaxChars(pDX, m_szName, 16);
	DDX_Text(pDX, IDC_OPTION_PORT, m_nServicePort);
	DDV_MinMaxUInt(pDX, m_nServicePort, 1, 65535);
	DDX_Text(pDX, IDC_OPTION_PROXYPORT, m_nProxyPort);
	DDV_MinMaxUInt(pDX, m_nProxyPort, 1, 65535);
	DDX_CBIndex(pDX, IDC_OPTION_PROXYTYPE, m_nProxyType);
	DDX_Text(pDX, IDC_OPTION_SERVER, m_szProxy);
	DDV_MaxChars(pDX, m_szProxy, 128);
	DDX_Check(pDX, IDC_OPTION_USEPROXY, m_bUseProxy);
	DDX_CBIndex(pDX, IDC_OPTION_WAITTIME, m_nWaitTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionDlg, CDialog)
	//{{AFX_MSG_MAP(COptionDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionDlg message handlers
